<?xml version="1.0" ?>

<!-- 	 
############################################################################################## 
############################################################################################## 
##
##	Nome: rub2vcard.xsl
##	versione: 0.1 
##	Copyright (C) 2000-2002 Nicola Fragale <nicolafragale@libero.it>
##	
##	Scopo: Questo foglio di stile traduce i file generati da Rubrica (.rub) in vcard
##	       This stylesheet translate rubrica's (.rub) file in vcard
##       
##	This program is free software; you can redistribute it and/or modify
##	it under the terms of the GNU General Public License as published by
## 	the Free Software Foundation; either version 2 of the License, or
##  	(at your option) any later version.
##
## 	This program is distributed in the hope that it will be useful,
##  	but WITHOUT ANY WARRANTY; without even the implied warranty of
##  	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  	GNU General Public License for more details.
##
##  	You should have received a copy of the GNU General Public License
##  	along with this program; if not, write to the Free Software
##  	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
##  	
#############################################################################################
#############################################################################################
-->
	
	<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">	
	<xsl:output method="text" encoding="ISO-8859-1"/>
	
		<xsl:template match="Rubrica">
					<xsl:apply-templates/>		
		</xsl:template>
		
		<!--				Card/Scheda
		-->
		<xsl:template match="Card">
BEGIN:VCARD
FN:<xsl:value-of select="@name"/>
<xsl:apply-templates select="Data"/>
<xsl:apply-templates select="Address"/>
<xsl:apply-templates select="WebAddresses"/>
<xsl:apply-templates select="EmailAddresses"/>
<xsl:apply-templates select="TelephoneNumbers"/>	
END:VCARD						
		</xsl:template>
		
		
		<!--			Personal infos/Dati Personali
		-->
<xsl:template match="Data">
N:<xsl:if test="LastName!=''"><xsl:value-of select="LastName"/>;</xsl:if><xsl:if test="FirstName!=''"><xsl:value-of select="FirstName"/>;</xsl:if><xsl:if test="MiddleName!=''"><xsl:value-of select="MiddleName"/>;</xsl:if><xsl:if test="NamePrefix!=''"><xsl:value-of select="NamePrefix"/>;</xsl:if><xsl:if test="Title!=''"><xsl:value-of select="Title"/>;</xsl:if>
			
<xsl:if test="FirstName/@know_birthday='true'">
BDAY:<xsl:value-of select="FirstName/@birthday"/>
</xsl:if>
</xsl:template>			

		<!--			Address/Indirizzo
		-->
	<xsl:template match="Address">
		<xsl:if test="Street!=''">
ADR;HOME:</xsl:if><xsl:if test="ZipCode!=''"><xsl:value-of select="ZipCode"/>;;<xsl:value-of select="Street"/><xsl:value-of select="StreetNumber"/>;</xsl:if><xsl:if test="City!=''"><xsl:value-of select="City"/>;</xsl:if><xsl:if test="Province!=''"><xsl:value-of select="Province"/>;;</xsl:if><xsl:if test="Country!=''"><xsl:value-of select="Country"/>;</xsl:if>
	</xsl:template>
		
		
		<!-- 			Web 
		-->
	<xsl:template match="WebAddresses">			
		<xsl:apply-templates select="Web"/>
	</xsl:template>		
	
	<xsl:template match="Web">
URL:<xsl:value-of select="."/> 
	</xsl:template>			

<!-- 			Email 
-->
	<xsl:template match="EmailAddresses">			
		<xsl:apply-templates select="Email"/>	
	</xsl:template>
		
		<xsl:template match="Email">
EMAIL;AOL:<xsl:value-of select="."/>
		</xsl:template>
		

<!-- 			Telephone/Telefono 
-->
	<xsl:template match="TelephoneNumbers">			
		<xsl:apply-templates select="Telephone"/>			
	</xsl:template>		
		
		<xsl:template match="Telephone">
TEL;<xsl:value-of select="@type"/>:<xsl:value-of select="."/> 
		</xsl:template>

	</xsl:stylesheet>

		<!-- 	end of file
		-->
