<?xml version="1.0" encoding="UTF-8"?>

<!-- 	 
###############################################################################
###############################################################################
## 
##   Nome: rub2rub.xsl 
##   versione: 0.4  
##   Copyright (C) Nicola Fragale <nicolafragale@libero.it> 
##	
##   Scopo: tradurre i file generati da una vecchia versione di Rubrica
##          (.rub)  nel formato adottato dall'ultima versione 
##    
##   This program is free software; you can redistribute it and/or modify 
##   it under the terms of the GNU General Public License as published by 
##   the Free Software Foundation; either version 2 of the License, or 
##   (at your option) any later version. 
##
##   This program is distributed in the hope that it will be useful, 
##   but WITHOUT ANY WARRANTY; without even the implied warranty of 
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
##   GNU General Public License for more details. 
##
##   You should have received a copy of the GNU General Public License 
##   along with this program; if not, write to the Free Software 
##   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
##  	
###############################################################################
###############################################################################
--> 
	
	<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml"/>	

		<xsl:template match="Rubrica">
			<Rubrica version="1.1.50" fileformat="4" doctype="AddressBook">
				<xsl:apply-templates/>
			</Rubrica>
		</xsl:template>		
		


		<!-- Import data from "Card" (file format 2 and 3), and
			  export to "Card" (file format 4)
			  
			  importa i dati da "Card" => formato file 2-3
		     ed esporta a "Card" formato file 4
		--> 
		<xsl:template match="Card">
			<Card name="{./@name}"
						deletable="{./@deleting}" 
					  deleted="false"
  					rank="2" 
						id="0"	
			      created="{./@created}" 
            last_change="{./@last_change}">
				<Groups>
					<Group><xsl:value-of select="./@group"/></Group>
				</Groups>
				 	
				<xsl:apply-templates select="Data"/>
					<Addresses>   
					  	<xsl:apply-templates select="Address"/>
					</Addresses>
		  	<xsl:apply-templates select="WebAddresses"/>   
		  	<xsl:apply-templates select="EmailAddresses"/>    
		 	 	<xsl:apply-templates select="TelephoneNumbers"/>    
	  		<xsl:apply-templates select="Company"/>    
	  		<xsl:apply-templates select="Work"/>   
		  	<xsl:apply-templates select="Notes"/>  
			</Card>
		</xsl:template>
	 	
	 	
		<!-- template per importare il formato file 2/3 -->	
		<xsl:template match="Data">
			<Data>
				<FirstName> 
					<xsl:value-of select="FirstName"/>  
				</FirstName>  
	      				      			
 	 			<MiddleName>
  					<xsl:value-of select="MiddleName"/> 
 				</MiddleName> 
	      			
				<LastName> 
					<xsl:value-of select="LastName"/> 
				</LastName> 

				<NickName></NickName>

				<Profession> 
					<xsl:value-of select="Profession"/>  
  			</Profession> 
	      			
 	 			<NamePrefix>
 		 			<xsl:value-of select="NamePrefix"/>  
 				</NamePrefix> 
  			
 				<Title>
  				<xsl:value-of select="Title"/>  
  			</Title> 
					
				<BirthDay known="{./FirstName/@know_birthday}" 
									birthday="{./FirstName/@birthday}"
									day="" month="" year="">
				</Birthday>
			</Data>	
		</xsl:template>
		
		
		<xsl:template match="Address">	
			<Address type="unknown">
				<Street number="{./StreetNumber}"> 
		 			<xsl:value-of select="Street"/> 
	  		</Street> 
<!--	      			
		  		<StreetNumber>  
		  			<xsl:value-of select="StreetNumber"/>  
		  		</StreetNumber>	 		 
      		
		 		<ZipCode>  
					<xsl:value-of select="ZipCode"/>  
				</ZipCode>  
-->			
				<City zip="{./ZipCode}">  
					<xsl:value-of select="City"/>  
				</City>  
		
				<Province>  
					<xsl:value-of select="Province"/>  
				</Province>  
		
				<State>
					<xsl:value-of select="State"/> 
				</State> 
				
				<Country>  
					<xsl:value-of select="Country"/>  
				</Country> 
			</Address>
		</xsl:template>

		<xsl:template match="WebAddresses"> 
			<WebAddresses>  
				<xsl:apply-templates select="Web"/> 
			</WebAddresses>  
		</xsl:template> 
		

		<xsl:template match="Web"> 
			<Web>  
				<xsl:value-of select="."/>  
			</Web>  
		</xsl:template>
		
				
		<xsl:template match="EmailAddresses"> 
			<EmailAddresses>  			
				<xsl:apply-templates select="Email"/> 
			</EmailAddresses>	   	 	
		</xsl:template>				 
		
				
		<xsl:template match="Email">
			<Email>   
				<xsl:value-of select="."/> 
			</Email>  	
		</xsl:template>			
		
		
		<xsl:template match="TelephoneNumbers"> 
			<TelephoneNumbers>  
				<xsl:apply-templates select="Telephone"/> 
			</TelephoneNumbers>  
		</xsl:template> 
		
		
		<xsl:template match="Telephone"> 
			<xsl:variable name="type"> 
				<xsl:if test="./@type='home'">home</xsl:if> 
				
				<xsl:if test="./@type='work'">work</xsl:if> 
				
				<xsl:if test="./@type='fax'">fax</xsl:if> 
				
				<xsl:if test="./@type='cellphone'">cellphone</xsl:if>	 
										
				<xsl:if test="./@type='other'">other</xsl:if> 
			</xsl:variable> 
			
			<xsl:if test="Telephone!=''">
				<Telephone type="{$type}"> 
					<xsl:value-of select="."/> 
				</Telephone>		 
			</xsl:if>
		</xsl:template> 
		
		
		<xsl:template match="Company">
	     	<Company> 
		  		<CompanyName>
		  			<xsl:value-of select="CompanyName"/>  
		  		</CompanyName> 
		  		<Street number="{./StreetNumber}">
		  			<xsl:value-of select="Street"/>  
		  		</Street> 
<!--		  		
	 	 		<StreetNumber>
		  			<xsl:value-of select="StreetNumber"/>  
	 	 		</StreetNumber> 
	  			<ZipCode>
		  			<xsl:value-of select="ZipCode"/>  
	  			</ZipCode> 
-->	  			
	  			<City zip="{./ZipCode}">
		  			<xsl:value-of select="City"/>  
	  			</City> 
	  			<Province>
		  			<xsl:value-of select="Province"/>  
	  			</Province> 
		  		<Country>
		  			<xsl:value-of select="Country"/>  
		  		</Country> 
		  		<Web>
		  			<xsl:value-of select="Web"/>  
		  		</Web> 
	 	 		<Email>
		  			<xsl:value-of select="Email"/>  
	 	 		</Email> 
	  			<Operator>
		  			<xsl:value-of select="Operator"/>  
	  			</Operator> 
	  			<Fax>
		  			<xsl:value-of select="Fax"/>  
	  			</Fax> 
	  			<Green>
		  			<xsl:value-of select="Green"/>  
	  			</Green> 
		  		<CustomerCare>
		  			<xsl:value-of select="CustomerCare"/>  
		  		</CustomerCare> 
		  		<Notes>
		  			<xsl:value-of select="Notes"/>  
		  		</Notes> 
			</Company> 	
		</xsl:template>
		
				
		<xsl:template match="Work">
			<Work> 
		 		<Assigment>
		 			<xsl:value-of select="Assigment"/>  
		 		</Assigment> 

	   		<Organization>
	  				<xsl:value-of select="Organization"/>  
				</Organization> 

     			<Department>		 			
	     			<xsl:value-of select="Department"/>  
				</Department> 

   			<SubDepartment>		 			
	     			<xsl:value-of select="SubDepartment"/>  
				</SubDepartment> 

	     		<SecretaryName>		 			
   		  		<xsl:value-of select="SecretaryName"/>  
				</SecretaryName> 

	     		<Secretaryphone>		 			
   		  		<xsl:value-of select="Secretaryphone"/>  
				</Secretaryphone> 
			</Work>   
      </xsl:template>		      			      


		<xsl:template match="Notes">
			<Notes married="{./@married}" know_birthday="true" 
				know_anniversary="true">  
				<SpouseName birthday="{./SpouseName/@birthday}" 
					anniversary="{./SpouseName/@anniversary}">
					<xsl:value-of select="SpouseName"/> 
				</SpouseName>  

			 	<Child>
					<xsl:value-of select="Child"/>  
			 	</Child>  

		 		<OtherNotes>  
					<xsl:apply-templates select="OtherNotes"/> 
				</OtherNotes>  

				<PublicKey>
					<xsl:value-of select="PublicKey"/>  
				</PublicKey>  			
			</Notes>   	
		</xsl:template>
 	
	</xsl:stylesheet>

	<!-- 	end of file
	-->
