/*
*  program name: Rubrica <http://digilander.iol.it/nfragale/download.html>
*  file: card.h
*  
*  Copyright (C) 2000-2003 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef __RUBRICA_CARD_H
#define __RUBRICA_CARD_H

#include <gtk/gtk.h>
#include <gconf/gconf-client.h>
#include <libxml/tree.h>
#include <libxml/parser.h>

#include "rubrica.h"
#include "item.h"


enum
  {
    CARD_COLUMN,
    FIRST_NAME_COLUMN,
    LAST_NAME_COLUMN,
    PROFESSION_COLUMN,
    CITY_COLUMN,
    COUNTRY_COLUMN,
    WEB_CARD_COLUMN,
    EMAIL_CARD_COLUMN,
    TELEPHONE_COLUMN,
    COMPANY_COLUMN,
    ASSIGMENT_COLUMN,
    CREATED_COLUMN,
    CHANGED_COLUMN,
    ID_COLUMN,
    COLUMNS
  };


RubricaDoc*   rubrica_card_add_page_view        (gchar *filename);

GtkTreeModel* rubrica_card_create_model         (void);
void          rubrica_card_add_columns          (GtkTreeView *view);

RubricaItem*  rubrica_card_get_nth_item         (GtkTreeView *view, gint n);

void          rubrica_card_insert_item          (RubricaDoc *doc,
						 RubricaItem *r, 
						 gint index,
						 gpointer user_data);

gulong        rubrica_card_get_selected_item_id (RubricaDoc* doc);

void          rubrica_card_modify_item          (RubricaDoc *doc,
						 RubricaItem* new, 
						 gint index);

// RubricaItem* rubrica_card_get_appending_item   (RubricaDoc* doc);

gboolean         rubrica_card_remove_selected_item (RubricaDoc *doc);
gboolean         rubrica_card_remove_last_item     (RubricaDoc *doc);
gboolean         rubrica_card_remove_nth_item      (RubricaDoc *doc, gint n);

/*
gboolean         rubrica_card_free_memory          (GtkTreeModel *model, 
						    GtkTreePath *path, 
						    GtkTreeIter *iter, 
						    gpointer data);
*/

void rubrica_card_cut_item             (RubricaDoc *doc);
// RubricaItem* rubrica_card_clone_item           (RubricaItem *item);

void             rubrica_card_row_selected         (GtkTreeSelection *select,
						    gpointer data);
void             rubrica_card_row_activated        (GtkTreeView *tree_view,
						    GtkTreePath *path,
						    GtkTreeViewColumn *column);
/*
gint             rubrica_card_popup_call           (GtkWidget *widget,
						    GdkEvent *event);
void             rubrica_card_detach_menu          (GtkWidget *attach_widget,
						    GtkMenu *menu);
*/
#endif
