/*
*  Rubrica
*  file: rubrica.h
*  
*  Copyright (C) 2000-2003 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RUBRICA_DOC_TAB_H
#define _RUBRICA_DOC_TAB_H

#include <gnome.h>

typedef struct _RubricaDocTab   RubricaDocTab;


struct _RubricaDocTab
{
  /* public */
  GtkWidget* label;     /* label (file name) on notebook's tab */

  /* private */
  GtkWidget* box;       /* widgets container           */
  GtkTooltips* ttips;   /* tooltips for close button   */
  GtkWidget* green;     /* green ligth, unchanged file */
  GtkWidget* red;       /* red ligth, file has changed */
  GtkWidget* close;     /* close button                */
};

RubricaDocTab* rubrica_doc_tab_new          (gchar* name);
void           rubrica_doc_tab_set_label    (RubricaDocTab* tab, 
					     gchar *label);
void           rubrica_doc_tab_enable_green (RubricaDocTab* tab);
void           rubrica_doc_tab_enable_red   (RubricaDocTab* tab);



#endif
