/*
*  Rubrica
*  file: file_utils.h
*  
*  Copyright (C) 2000-2003 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __RUBRICA_FILE_UTILS_H
#define __RUBRICA_FILE_UTILS_H

#include <gnome.h>
#include <libxml/tree.h>
#include <libxml/parser.h>

#include "rubrica_type.h"
#include "rubrica.h"

xmlDocPtr rubrica_file_utils_open_doc              (gchar *filename);

gint      rubrica_file_utils_get_fileformat        (xmlDocPtr xmldoc);
gchar*    rubrica_file_utils_get_version           (xmlDocPtr xmldoc);
gchar*    rubrica_file_utils_get_document_tpye     (xmlDocPtr xmldoc);
gboolean  rubrica_file_utils_is_rubrica_doc        (xmlDocPtr xmldoc, 
						    gchar *filename);

gchar*    rubrica_file_utils_get_node_content      (xmlNodePtr node);
gchar*    rubrica_file_utils_get_node_property     (xmlNodePtr node, 
						    const gchar* key);
gchar*    rubrica_file_utils_get_card_name         (xmlNodePtr node);
gboolean  rubrica_file_utils_get_boolean_property  (xmlNodePtr node,
						    gchar* key);
glong     rubrica_file_utils_get_date_property     (xmlNodePtr node, 
						    gchar* key);
time_t    rubrica_file_utils_get_calendar_property (xmlNodePtr node);

gboolean  rubrica_file_utils_has_rub_extension     (gchar *filename);

void      rubrica_file_utils_do_backup             (RubricaDoc *rubrica, 
						    gchar *oldfilename);
void      rubrica_file_utils_do_bak_backup         (RubricaDoc *rubrica, 
						    gchar *oldfilename);

gboolean  rubrica_file_utils_import_old_file       (gchar* fname);
gboolean  rubrica_file_utils_load_ff3_doc          (RubricaDoc *doc, 
						    RubricaErrorType *err);
#endif
