/*
*  Rubrica
*  file: prefer.h
*
*  
*  Copyright (C) 2000-2003 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __RUBRICA_PREFERENCES_H
#define __RUBRICA_PREFERENCES_H

#include <gnome.h>
#include <config.h>
#include <gconf/gconf-client.h>
#include "rubrica_type.h"

/* TODO 
   importare le vecchie chiavi
   RUBRICA_KEY_LAST_BOOK ("/apps/rubrica/last_book") ==> 
   RUBRICA_KEY_LAST_DOC  ("/apps/rubrica/last_doc")
   
   RUBRICA_KEY_HAVE_ ==> 
   RUBRICA_KEY_HAVE_DOC ("/apps/rubrica/file/load_document")
   
   RUBRICA_KEY_HAVE_ ==> 
   RUBRICA_KEY_DOC      ("/apps/rubrica/file/document")
*/

/* 
 *   /apps/rubrica keys 
 */
// #define RUBRICA_KEY_VERSION_MAJOR     "/apps/rubrica/version"
#define RUBRICA_KEY_FILE_FORMAT       "/apps/rubrica/file_format"
// #define RUBRICA_KEY_VERSION_MINOR     "/apps/rubrica/version_minor"
#define RUBRICA_KEY_FIRST_RUN         "/apps/rubrica/first_run" 
#define RUBRICA_KEY_UPGRADE_OLD_KEYS  "/apps/rubrica/private/upgrade_old_keys"
#define RUBRICA_KEY_LAST_RUN          "/apps/rubrica/last_run"
#define RUBRICA_KEY_LAST_BOOK         "/apps/rubrica/last_book"
#define RUBRICA_KEY_HOME              "/apps/rubrica/home"
#define RUBRICA_KEY_RUBRICA_HOME      "/apps/rubrica/rubrica_home"
#define RUBRICA_KEY_ENABLE_RESIZE     "/apps/rubrica/enable_resize"
#define RUBRICA_KEY_WIDTH             "/apps/rubrica/width"     // altezza
#define RUBRICA_KEY_LENGTH            "/apps/rubrica/length"    // lunghezza



/*
 *   /apps/rubrica/file keys
 */
#define RUBRICA_KEY_SHOW              "/apps/rubrica/file/show_path"
#define RUBRICA_KEY_HAVE_BOOK         "/apps/rubrica/file/load_addressbook" //  deprecated
#define RUBRICA_KEY_BOOK              "/apps/rubrica/file/addressbook"      //  deprecated 
#define RUBRICA_KEY_HAVE_DOC          "/apps/rubrica/file/load_document"
#define RUBRICA_KEY_DOC               "/apps/rubrica/file/document"
#define RUBRICA_KEY_HAVE_FOLDER       "/apps/rubrica/file/have_default_folder"
#define RUBRICA_KEY_FOLDER            "/apps/rubrica/file/folder"
#define RUBRICA_KEY_BACKUP            "/apps/rubrica/file/do_backup"
#define RUBRICA_KEY_BACKUP_TYPE_INC   "/apps/rubrica/file/backup_type_inc"
#define RUBRICA_KEY_BACKUP_TYPE_BAK   "/apps/rubrica/file/backup_type_bak"
#define RUBRICA_KEY_COMPRESS          "/apps/rubrica/file/compress_addressbook"
#define RUBRICA_KEY_RATE              "/apps/rubrica/file/compression_rate"
#define RUBRICA_KEY_AUTOSAVE          "/apps/rubrica/file/autosave"
#define RUBRICA_KEY_WAIT_TIME         "/apps/rubrica/file/wait_time"

/*
 *   /apps/rubrica/general keys
 */
#define RUBRICA_KEY_SORT_TYPE         "/apps/rubrica/general/sort_type"
#define RUBRICA_KEY_SORT_DIRECTION    "/apps/rubrica/general/sort_direction"
#define RUBRICA_KEY_SEARCH_TYPE       "/apps/rubrica/general/search_type"
#define RUBRICA_KEY_SEARCH_SENSITIVE  "/apps/rubrica/general/search_case_sensitive"
#define RUBRICA_KEY_SEARCH_COMPLETE   "/apps/rubrica/general/search_complete_string"
#define RUBRICA_KEY_EXIT              "/apps/rubrica/general/confirm_exit"
#define RUBRICA_KEY_TOOLTIPS          "/apps/rubrica/general/enable_tooltips"
#define RUBRICA_KEY_TOOLBAR_STYLE     "/apps/rubrica/general/toolbar_style"
#define RUBRICA_KEY_SHOW_GROUPS       "/apps/rubrica/general/groups"
/*
 *   /apps/rubrica/fonts keys
 */
#define RUBRICA_KEY_FONT_HEADER       "/apps/rubrica/fonts/header"
#define RUBRICA_KEY_FONT_DATA         "/apps/rubrica/fonts/data"

/*
 *   /apps/rubrica/colours keys
 */
#define RUBRICA_KEY_COLOUR_HEADER     "/apps/rubrica/colours/header"
#define RUBRICA_KEY_COLOUR_DATA       "/apps/rubrica/colours/data"


/*
 *   /apps/rubrica/cryptograpy
 */
#define RUBRICA_KEY_CRYPTOGRAPHY    "/apps/rubrica/cryptograpy"
#define RUBRICA_CRYPT_ALL_DATA      "crypt_all"
#define RUBRICA_CRYPT_MARKED_DATA   "crypt_marked"
#define RUBRICA_DECRYPT_ALL_DATA    "decrypt_all"
#define RUBRICA_DECRYPT_MARKED_DATA "decrypt_marked"


/*
 *   SCC ==> SHOW_CARD_COLUMN
 *   SAC ==> SHOW_ACCOUNT_COLUMN
 *   SCD ==> SHOW_DATA        (Show_Card_Data)
 *   SAD ==> SHOW_ACCOUNT     (Show_Account_Data)
 *
 *   /apps/rubrica/show keys
 */ 
// #define RUBRICA_KEY_SCC_PIXMAP      "/apps/rubrica/show/card/column/pixmap"
#define RUBRICA_KEY_SCC_CARD        "/apps/rubrica/show/card/column/card"
#define RUBRICA_KEY_SCC_FIRST_NAME  "/apps/rubrica/show/card/column/first_name"
#define RUBRICA_KEY_SCC_LAST_NAME   "/apps/rubrica/show/card/column/last_name"
#define RUBRICA_KEY_SCC_PROFESSION  "/apps/rubrica/show/card/column/profession"
#define RUBRICA_KEY_SCC_CITY        "/apps/rubrica/show/card/column/city"
#define RUBRICA_KEY_SCC_COUNTRY     "/apps/rubrica/show/card/column/country"
#define RUBRICA_KEY_SCC_WEB         "/apps/rubrica/show/card/column/web"
#define RUBRICA_KEY_SCC_EMAIL       "/apps/rubrica/show/card/column/email"
#define RUBRICA_KEY_SCC_TELEPHONE   "/apps/rubrica/show/card/column/telephone"
#define RUBRICA_KEY_SCC_COMPANY     "/apps/rubrica/show/card/column/company"
#define RUBRICA_KEY_SCC_ASSIGMENT   "/apps/rubrica/show/card/column/assigment"
// #define RUBRICA_KEY_SCC_CATEGORIES  "/apps/rubrica/show/card/column/categories"




#define RUBRICA_KEY_SCD_FIRST_NAME     "/apps/rubrica/show/card/data/personal/first_name"
#define RUBRICA_KEY_SCD_MIDDLE_NAME    "/apps/rubrica/show/card/data/personal/middle_name"
#define RUBRICA_KEY_SCD_LAST_NAME      "/apps/rubrica/show/card/data/personal/last_name"
#define RUBRICA_KEY_SCD_NICKNAME       "/apps/rubrica/show/card/data/personal/nickname"
#define RUBRICA_KEY_SCD_PROFESSION     "/apps/rubrica/show/card/data/personal/profession"
#define RUBRICA_KEY_SCD_NAME_PREFIX    "/apps/rubrica/show/card/data/personal/name_prefix"
#define RUBRICA_KEY_SCD_TITLE          "/apps/rubrica/show/card/data/personal/title"
#define RUBRICA_KEY_SCD_BIRTHKNOW      "/apps/rubrica/show/card/data/personal/birthknow"
#define RUBRICA_KEY_SCD_BIRTHDAY       "/apps/rubrica/show/card/data/personal/birthday"

#define RUBRICA_KEY_SCD_STREET         "/apps/rubrica/show/card/data/personal/street"
#define RUBRICA_KEY_SCD_STREET_NUM     "/apps/rubrica/show/card/data/personal/street_number"
#define RUBRICA_KEY_SCD_ZIP_CODE       "/apps/rubrica/show/card/data/personal/zip_code"
#define RUBRICA_KEY_SCD_CITY           "/apps/rubrica/show/card/data/personal/city"
#define RUBRICA_KEY_SCD_PROVINCE       "/apps/rubrica/show/card/data/personal/province"
#define RUBRICA_KEY_SCD_STATE          "/apps/rubrica/show/card/data/personal/state"
#define RUBRICA_KEY_SCD_COUNTRY        "/apps/rubrica/show/card/data/personal/country"


#define RUBRICA_KEY_SCD_WEB    "/apps/rubrica/show/card/data/communicate/web"
#define RUBRICA_KEY_SCD_EMAIL  "/apps/rubrica/show/card/data/communicate/email"
#define RUBRICA_KEY_SCD_TELEPHONE  "/apps/rubrica/show/card/data/communicate/telephone"


#define RUBRICA_KEY_SCD_COMPANY            "/apps/rubrica/show/card/data/company/company"
#define RUBRICA_KEY_SCD_COMPANY_STREET     "/apps/rubrica/show/card/data/company/street"
#define RUBRICA_KEY_SCD_COMPANY_STREET_NUM "/apps/rubrica/show/card/data/company/street_number"
#define RUBRICA_KEY_SCD_COMPANY_ZIP_CODE   "/apps/rubrica/show/card/data/company/zip_code"
#define RUBRICA_KEY_SCD_COMPANY_CITY       "/apps/rubrica/show/card/data/company/city"
#define RUBRICA_KEY_SCD_COMPANY_PROVINCE   "/apps/rubrica/show/card/data/company/province"
#define RUBRICA_KEY_SCD_COMPANY_COUNTRY    "/apps/rubrica/show/card/data/company/country"
#define RUBRICA_KEY_SCD_COMPANY_WEB        "/apps/rubrica/show/card/data/company/web"
#define RUBRICA_KEY_SCD_COMPANY_EMAIL      "/apps/rubrica/show/card/data/company/email"
#define RUBRICA_KEY_SCD_OPERATOR           "/apps/rubrica/show/card/data/company/operator"
#define RUBRICA_KEY_SCD_FAX                "/apps/rubrica/show/card/data/company/fax"
#define RUBRICA_KEY_SCD_GREEN              "/apps/rubrica/show/card/data/company/green"
#define RUBRICA_KEY_SCD_CUSTOMER_CARE      "/apps/rubrica/show/card/data/company/customer_care"
#define RUBRICA_KEY_SCD_COMPANY_NOTE       "/apps/rubrica/show/card/data/company/note"


#define RUBRICA_KEY_SCD_ASSIGMENT          "/apps/rubrica/show/card/data/assigment/assigment"
#define RUBRICA_KEY_SCD_ORG                "/apps/rubrica/show/card/data/assigment/organization"
#define RUBRICA_KEY_SCD_DEP                "/apps/rubrica/show/card/data/assigment/department"
#define RUBRICA_KEY_SCD_SUB_DEP            "/apps/rubrica/show/card/data/assigment/sub_department"
#define RUBRICA_KEY_SCD_SECRETARY          "/apps/rubrica/show/card/data/assigment/secretary_name"
#define RUBRICA_KEY_SCD_SECR_PHONE         "/apps/rubrica/show/card/data/assigment/secretary_phone"


#define RUBRICA_KEY_SCD_MARRIED        "/apps/rubrica/show/card/data/notes/is_married"
#define RUBRICA_KEY_SCD_SPOUSE         "/apps/rubrica/show/card/data/notes/spouse_name"
#define RUBRICA_KEY_SCD_SPOUSE_BIRTH   "/apps/rubrica/show/card/data/notes/spouse_birthday"
#define RUBRICA_KEY_SCD_ANNIVERSARY    "/apps/rubrica/show/card/data/notes/anniversary"
#define RUBRICA_KEY_SCD_HAS_CHILDREN   "/apps/rubrica/show/card/data/notes/has_children"
#define RUBRICA_KEY_SCD_CHILDREN       "/apps/rubrica/show/card/data/notes/children"
#define RUBRICA_KEY_SCD_HOBBIES        "/apps/rubrica/show/card/data/notes/hobbies"
#define RUBRICA_KEY_SCD_NOTE           "/apps/rubrica/show/card/data/notes/note"
#define RUBRICA_KEY_SCD_PUBLIC_KEY     "/apps/rubrica/show/card/data/notes/public_key"



gboolean            rubrica_preferences_upgrade_keys(void);
gboolean            rubrica_preferences_get_first_run(void);
gchar*              rubrica_preferences_get_home(void);       
gchar*              rubrica_preferences_get_rubrica_home(void);

gboolean            rubrica_preferences_get_show_path(void); 
gboolean            rubrica_preferences_get_have_default_addressbook(void); // deprecated
gchar*              rubrica_preferences_get_book(void);                     // deprecated
gboolean            rubrica_preferences_get_have_default_document(void);
gchar*              rubrica_preferences_get_doc(void);
gboolean            rubrica_preferences_get_have_default_folder(void);
gchar*              rubrica_preferences_get_default_folder(void); 
gboolean            rubrica_preferences_get_do_backup(void);      
gboolean            rubrica_preferences_get_backup_type(gchar *key); 
gboolean            rubrica_preferences_get_backup_is_increasing(void);
gboolean            rubrica_preferences_get_compress(void);  
gint                rubrica_preferences_get_compress_rate();
gboolean            rubrica_preferences_get_autosave(void); 
gint                rubrica_preferences_get_time_rate(void);
 
gint                rubrica_preferences_get_sort_type(void);
gint                rubrica_preferences_get_sort_direction(void);
gint                rubrica_preferences_get_search_type(void);
gboolean            rubrica_preferences_get_search_case(void);
gboolean            rubrica_preferences_get_search_mode(void);
gboolean            rubrica_preferences_get_exit(void);  
RubricaToolbarStyle rubrica_preferences_get_toolbarstyle(void);
RubricaToolbarStyle rubrica_preferences_get_desktop_toolbarstyle(void);   

/*
gboolean            rubrica_preferences_get_use_default_dictionary(void); 
gboolean            rubrica_preferences_get_use_user_dictionary(void);  
gboolean            rubrica_preferences_get_use_italian_dictionary(void);
gchar*              rubrica_preferences_get_dictionary_home(void);    
gchar*              rubrica_preferences_get_user_dictionary(void);    

#define user_wants_default_dictionary() rubrica_preferences_get_use_default_dictionary()
#define user_wants_italian_dictionary() rubrica_preferences_get_use_italian_dictionary()
*/


#define rubrica_run_first_time() rubrica_preferences_get_first_run() 
#define backup_is_increasing() rubrica_preferences_get_backup_is_increasing()


void rubrica_preferences_set_first_run(gboolean bool);
void rubrica_preferences_set_last_run(time_t last_run);

void rubrica_preferences_set_last_book(gchar *filename);
void rubrica_preferences_set_home(gchar *home);
void rubrica_preferences_set_rubrica_home(gchar *home);

void rubrica_preferences_set_have_default_doc(gboolean bool);
void rubrica_preferences_set_have_default_folder(gboolean bool);
void rubrica_preferences_set_doc(gchar *str);
void rubrica_preferences_set_folder(gchar *str);
void rubrica_preferences_set_case_sensitive_search(gboolean state);
void rubrica_preferences_set_complete_search(gboolean state);
void rubrica_preferences_set_incomplete_search(gboolean state);

/*
void rubrica_preferences_set_user_dictionary(gchar *dict);
void rubrica_preferences_set_dictionary_home(gchar *dict_home);
*/

#endif
