/*
*  Rubrica
*  file: rubrica_type.h
*  
*  Copyright (C) 2000-2003 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RUBRICA_TYPE_H
#define _RUBRICA_TYPE_H


#define RUBRICA_FILE_FORMAT  FILE_FORMAT

/*
typedef enum {
  DOC_MASTER           = -1,
  ADDRESSBOOK_DOC_TYPE = 0,
  ACCOUNT_DOC_TYPE,
  BLOCK_NOTES_DOC_TYPE,
  UNKNOWN_DOC
} RubricaDocType;
*/

/*
typedef enum {
  ACCOUNT_TYPE = 0,
  CARD_TYPE
} RubricaType;
*/
/*
typedef enum {
  CARD_VIEW    = 0,
  ACCOUNT_VIEW
} RubricaViewType;
*/

typedef enum {
  GROUP_BELONG_COLUMN = 0,       // card belongs to this group
  GROUP_PIXMAP_COLUMN,           // group pixmap
  GROUP_LABEL_COLUMN,            // group pixmap 
  GROUP_TYPE_COLUMN,             // group type (hidden column) 
  GROUP_LAST_COLUMN 
} RubricaGroupColumnType;


typedef enum {
  ADDRESS_STREET_COLUMN = 0,
  ADDRESS_NUMBER_COLUMN,
  ADDRESS_TYPE_COLUMN,
  ADDRESS_DATA_COLUMN,
  LAST_ADDRESS_COLUMN
} RubricaAddressColumnType;

typedef enum {
  URI_COLUMN = 0,
  LAST_NET_COLUMN
} RubricaNetColumnType;


typedef enum {
  NUMBER_COLUMN = 0,
  TYPE_COLUMN,
  LAST_TEL_COLUMN
} RubricaPhoneColumnType;


typedef enum {
  VBOX = 0,
  HBOX
} RubricaBoxType;

typedef enum {
  CARD_TREE = 0,             // cards list (main window treeview)
  GROUP_TREE,                // categories/group list (card form)
 // ACCOUNT_TREE,              // accounts list (main window treeview) 
  ADDRESS_TREE,              // addresses list (card form)
  NET_TREE,                  // web/email list (card form)
  PHONE_TREE,                // telephone list (card form)
  PREF_TREE,                 // preferences tree-index
  PREF_CARD_LIST,            // card columns 
//  PREF_ACCOUNT_LIST,         // account columns
  PREF_PERSONAL_DATA_LIST,   // personal data list
  PREF_PERSONAL_MEDIA_LIST,  // 
  PREF_COMPANY_DATA_LIST,    // company data list
  PREF_NOTE_DATA_LIST,       // note data list
//  PREF_ACCOUNT_DATA_LIST     // account data list
} RubricaTreeType;

typedef enum {
  GROUP_MODEL = 0,
  ADDRESS_MODEL,
  NET_MODEL,
  TELEPHONE_MODEL
} RubricaModelType;

typedef enum {
  GROUP_COLUMNS = 0,
  ADDRESS_COLUMNS,
  WEB_COLUMNS,  
  EMAIL_COLUMNS,
  TELEPHONE_COLUMNS
} RubricaColumnsType;

/*
typedef enum {
  CARD_FORM_TYPE = 0,
  ACCOUNT_FORM_TYPE
} RubricaFormType;
*/

typedef enum {
  NEW_CARD = 0,
  OLD_CARD
} RubricaCardType;



typedef enum {
  NO_GROUP         = 0,
  ALL_GROUP,
  FAVORITES_GROUP,
  HOT_GROUP,
  FRIENDS_GROUP,
  HEART_GROUP, 
  RELATIVES_GROUP,
  HOLIDAYS_GROUP,
  HOBBIES_GROUP,
  SPORT_GROUP,
  BUSSINES_GROUP,
  COMPANY_GROUP,
  WORK_GROUP,
  CUSTOMER_GROUP,
  STRATEGIES_GROUP,
  PROGRAMMERS_GROUP,
  BSD_GROUP,
  PLUTO_GROUP
} RubricaGroupType;


typedef enum  {
  TELEPHONE_HOME = 0,
  TELEPHONE_WORK,
  TELEPHONE_FAX,
  TELEPHONE_CELLPHONE,
  TELEPHONE_OTHER,
  TELEPHONE_UNKNOWN
} RubricaTelephoneType;


typedef enum {
  RUBRICA_ADDRESS_PREF = 0,
  RUBRICA_ADDRESS_HOME,
  RUBRICA_ADDRESS_WORK,
  RUBRICA_ADDRESS_PARCEL,
  RUBRICA_ADDRESS_POSTAL,
  RUBRICA_ADDRESS_INTL,
  RUBRICA_ADDRESS_DOM,
  RUBRICA_ADDRESS_UNKNOWN
} RubricaAddressType;

/*
typedef enum {
  ITALIAN = 0,
  ENGLISH,
  USER, 
  UNKNOWN
} RubricaLanguageType;
*/

typedef enum {
  RT_DMY = 0,         /* dd/mm/yy */
  RT_MDY,             /* mm/dd/yy */
  RT_EXT_MDY,         /* month/day/year */
  RT_EXT_DMY          /* day/month/year */
} RubricaTimeType;


/* RDC ==> Rubrica Dictionary Code
typedef enum {
  RDC_CARD = 0,
  RDC_DATA, 
  RDC_ADDRESS, 
  RDC_COMPANY, 
  RDC_WORK,
  RDC_FIRST_NAME, 
  RDC_MIDDLE_NAME, 
  RDC_LAST_NAME, 
  RDC_PROFESSION, 
  RDC_NAME_PREFIX, 
  RDC_TITLE,
  RDC_STREET, 
  RDC_STREET_NUMBER, 
  RDC_ZIP_CODE, 
  RDC_CITY, 
  RDC_PROVINCE, 
  RDC_STATE, 
  RDC_COUNTRY, 
  RDC_WEB_ADDRESS, 
  RDC_WEB, 
  RDC_EMAIL_ADDRESS, 
  RDC_EMAIL, 
  RDC_TELEPHONE_NUMBERS, 
  RDC_TELEPHONE, 
  RDC_TYPE, 
  RDC_TELEPHONE_WORK, 
  RDC_TELEPHONE_HOME, 
  RDC_TELEPHONE_FAX, 
  RDC_TELEPHONE_CELL, 
  RDC_TELEPHONE_OTHER,
  RDC_COMPANY_NAME, 
  RDC_OPERATOR, 
  RDC_GREEN, 
  RDC_CUSTOMER_CARE,
  RDC_ASSIGMENT,
  RDC_ORGANIZATION,
  RDC_DEPARTMENT,
  RDC_SUB_DEPARTMENT, 
  RDC_SECRETARY,
  RDC_SECRETARY_PHONE, 
  RDC_SPOUSE,
  RDC_MARRIED,
  RDC_ANNIVERSARY,
//  RDC_CHILDREN,
  RDC_CHILDREN_NOTES, 
  RDC_NOTE,
  RDC_HOBBIES,
  RDC_PUBLIC_KEY, 
  RDC_BIRTHDAY,
  RDC_SPOUSE_NAME,
//  RDC_OTHER_NOTE,  
  RDC_CARD_GROUP,
  RDC_END
} RubricaDictionaryCode; 
 */
 

typedef enum {
  RUBRICA_FONT_HEADER,
  RUBRICA_FONT_DATA
} RubricaFontType;


/* RE ==> Rubrica Error */
typedef enum {
  RE_FILE_NOT_EXIST = 0,
  RE_NO_RUBRICA_DOC,
  RE_UNKNOWN_DOC,
  RE_NO_XML_DOC,
  RE_PARSE_XML_DOC,
  RE_XML_DOC_NO_RUBRICA_HEADER,
  RE_XML_DOC_NO_RUBRICA_FIELD,
  RE_SELECT_FILE,
  RE_IMPORT_FILE,
  RE_BAD_MODULE,
  RE_MODULE_IS_NULL,
  RE_ITEM_IS_NULL,
  RE_NO_ITEM_MODULE,
  RE_NO_FORM,  
  RE_NO_ERROR
} RubricaErrorType;


/* RB ==> Rubrica Browse */
typedef enum {
  RB_FIRST_CARD = 0,
  RB_LAST_CARD,
  RB_NEXT_CARD,
  RB_PREV_CARD,
  RB_NTH_CARD
} RubricaBrowseType;


/* RTS ==> Rubrica Toolbar Style */
typedef enum {
  RTS_ICONS = 0,
  RTS_TEXT,
  RTS_BOTH,
  RTS_BOTH_HORIZ,
  RTS_GNOME_DEFAULT
} RubricaToolbarStyle;


typedef enum {
  SORT_ALPHA = 0,
  SORT_CREATION_DATE,
  SORT_MODIFICATION_DATE
} RubricaSortType;


typedef enum {
  SORT_ASCENDING = 0,
  SORT_DESCENDING
} RubricaSortDirectionType;


typedef enum {
  SEARCH_CARD = 0,
  SEARCH_FIRST_NAME,
  SEARCH_LAST_NAME,
  SEARCH_PROFESSION,
  SEARCH_CITY,
  SEARCH_COUNTRY,
  SEARCH_WEB_ADDRESS,
  SEARCH_EMAIL_ADDRESS,
  SEARCH_TELEPHONE,
  SEARCH_COMPANY,
  SEARCH_CATEGORIES
} RubricaSearchType;


typedef enum {
  RUBRICA_RANK_NONE = 0,         /* no importance card */
  RUBRICA_RANK_FEW,              /* few importance card */
  RUBRICA_RANK_NORMAL,           /* normal card */
  RUBRICA_RANK_HIGHT,            /* hight importance card */
  RUBRICA_RANK_VERY_HIGHT        /* very hight importance card */
} RubricaRankType;


typedef enum {
  OPEN_RUBRICA = 0,
  OPEN_OLD_RUBRICA,
  OPEN_GNOMECARD,
  OPEN_KAB,
  OPEN_CSV_MOZILLA, 
  OPEN_CSV_NETSCAPE, 
  OPEN_VCARD,
  OPEN_PINE,
} RubricaImportType;

typedef enum {
  SAVE_RUBRICA = 0,
  SAVE_GNOMECARD,
  SAVE_KDE_VCARD,
  SAVE_MOZILLA_CSV, 
  SAVE_VCARD,
  SAVE_PINE,
  SAVE_HTML,
  SAVE_TXT
} RubricaExportType;


/*
typedef gchar RubricaDictionary;
typedef struct _RubricaDictionaryItem RubricaDictionaryItem;
*/
typedef struct _RubricaGroup          RubricaGroup;
typedef struct _RubricaOptionType     RubricaOptionType;

/*
struct _RubricaDictionaryItem {
  gchar* label;
  gchar* key;
};
*/

struct _RubricaGroup {
  gchar* label;

  RubricaGroupType type;  
};

struct _RubricaOptionType {
  gchar* pixmap;
  gchar* label;

  gint type;
};


typedef enum {
  RM_ITEM = 0,
  RM_HEADER,
  RM_CHECK_ITEM, 
  RM_RADIO_ITEM,
  RM_SEPARATOR,
  RM_ICONED_SUBTREE,
  RM_SUBTREE,
  RM_END
} RubricaMenuType;


typedef enum {
  RMP_NONE = 0,
  RMP_STOCK,
  RMP_FILE
} RubricaMenuPixmapType;


typedef void (*RubricaMenuFunc) (GtkMenuItem *item, gpointer data);
typedef struct _RubricaMenu RubricaMenu;

struct _RubricaMenu {
  RubricaMenuType type;           /* menu type */
  gchar *label;                   /* displayed label */
  gchar *tip;                     /* tip */

  RubricaMenuPixmapType pixtype;  /* pixmap type */
  gchar *pixmap;                  /* pixmap file */

  gpointer more;                  /* more data:
				     - subtree, for subtree menu 
				  */

  RubricaMenuFunc callback;       /* callback funcion */
  gpointer data;                  /* user data */
  // TODO: add hotkey
};

#define RUBRICA_MENU_ICONED_ITEM(label, pixtype, pixfile, callback, data) { \
                           RM_ITEM, (label), NULL, (pixtype),               \
                           (pixfile), NULL, (callback), (data)              \
                           }

#define RUBRICA_MENU_ITEM(label, callback, data) {           \
                          RM_ITEM, (label), NULL, RMP_NONE,  \
                          NULL, NULL, (callback), (data)     \
                          }

#define RUBRICA_MENU_RADIO(label, callback, data) {                 \
                           RM_RADIO_ITEM, (label), NULL, RMP_NONE,  \
                           NULL, NULL, (callback), (data)           \
                           }

#define RUBRICA_MENU_CHECK(label, callback, data) {                  \
                           RM_CHECK_ITEM, (label), NULL, RMP_NONE,   \
                           NULL, NULL, (callback), (data)            \
                           }

#define RUBRICA_MENU_SEPARATOR {                                \
                           RM_SEPARATOR, NULL, NULL, RMP_NONE,  \
                           NULL, NULL, NULL, NULL               \
                           }

#define RUBRICA_MENU_ICONED_SUBTREE(label, pixtype, pixfile, subtree) {  \
                           RM_ICONED_SUBTREE, (label), NULL, (pixtype),  \
                           (pixfile), (subtree), NULL, NULL              \
                           }

#define RUBRICA_MENU_SUBTREE(label, subtree) {                      \
                           RM_SUBTREE, (label), NULL,               \
                           RMP_NONE, NULL, (subtree), NULL, NULL    \
                           }

#define RUBRICA_MENU_END  { RM_END, NULL, NULL, RMP_NONE,   \
                            NULL, NULL,  NULL, NULL         \
                          }


#endif
