/*
*  Rubrica
*  file: ui.h
*
*  
*  Copyright (C) 2000-2003 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __RUBRICA_UI_H
#define __RUBRICA_UI_H

#include <gnome.h>
#include <gconf/gconf-client.h>

#include "rubrica_type.h"
#include "menu.h"

void       rubrica_ui_set_default_icon(GtkWidget *app);
GtkWidget* rubrica_ui_hig_frame_new(gchar *str);

GtkWidget* rubrica_ui_box_new(RubricaBoxType type, gboolean homogeneous,  
			      gint spacing, guint border_width); 
GtkWidget* rubrica_ui_frame_new(gchar *str); 
GtkWidget* rubrica_ui_scrolled_window_new(void); 

/* pixmap, image, ... */
GtkWidget* rubrica_ui_popup_image_new(gchar *pixfile);
GtkWidget* rubrica_ui_image_new(gchar *pixfile);   
GdkPixbuf* rubrica_ui_pixbuf_new(gchar *filename);

GtkWidget* rubrica_ui_option_menu_new(GtkWidget* opt_menu,
				      RubricaOptionType *option_list);
GtkWidget* rubrica_ui_popup_menu_new(RubricaMenu *rubrica_menu);

GtkWidget* rubrica_ui_date_new(void);

/*  text view
*/
GtkWidget* rubrica_ui_text_view_new    (void);
void       rubrica_ui_set_text_in_view (GtkWidget *text_view, gchar *buffer);
void       rubrica_ui_clean_text_view  (GtkWidget *text_view);


GtkWidget* rubrica_ui_default_box_new(RubricaBoxType type);  
GtkWidget* rubrica_ui_packed_check_button_new(GtkWidget *box, gchar *str);
GtkWidget* rubrica_ui_label_new(gchar *str, GtkWidget *target); 





/*   tree view
*/
GtkWidget* rubrica_ui_pack_in_frame_tree_view_new_with_model(GtkWidget *frame,
							     GtkTreeModel* model); 
GtkWidget * rubrica_ui_packed_tree_view_new_with_model(GtkWidget *container,
					   GtkTreeModel* model);
void rubrica_ui_update_popup_item(GConfClient *client, guint cnxn_id, 
				  GConfEntry *entry, gpointer data);



#endif
